dnl Copyright (c) Istituto Nazionale di Fisica Nucleare (INFN). 2006-2010.
dnl
dnl Licensed under the Apache License, Version 2.0 (the "License");
dnl you may not use this file except in compliance with the License.
dnl You may obtain a copy of the License at
dnl
dnl     http://www.apache.org/licenses/LICENSE-2.0
dnl
dnl Unless required by applicable law or agreed to in writing, software
dnl distributed under the License is distributed on an "AS IS" BASIS,
dnl WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
dnl See the License for the specific language governing permissions and
dnl limitations under the License.

dnl Usage:
dnl AC_EMI
dnl - EMI_LOCATION
dnl - EMI_CFLAGS
dnl - EMI_LDFLAGS

AC_DEFUN([AC_EMI],
[
    AC_ARG_WITH(emi_location,
        [  --with-emi-location=PFX     prefix where EMI is installed. (/usr)],
        [],
        with_emi_location=${EMI_LOCATION:-/usr})

    AC_MSG_CHECKING([for emi location])

    if test -n "with_emi_location" ; then
    	EMI_LOCATION="$with_emi_location"
	EMI_CFLAGS="-I$EMI_LOCATION/include"
        if test "x$host_cpu" = "xx86_64"; then
            EMI_LDFLAGS="-L$EMI_LOCATION/lib64"
        else
            EMI_LDFLAGS="-L$EMI_LOCATION/lib"
        fi
        AC_MSG_RESULT([$with_emi_location])
    else
        AC_MSG_ERROR([$with_emi_location: no such directory])
    fi

    AC_SUBST(EMI_LOCATION)
    AC_SUBST(EMI_CFLAGS)
    AC_SUBST(EMI_LDFLAGS)

])
