dnl Copyright (c) Istituto Nazionale di Fisica Nucleare (INFN). 2006-2010.
dnl
dnl Licensed under the Apache License, Version 2.0 (the "License");
dnl you may not use this file except in compliance with the License.
dnl You may obtain a copy of the License at
dnl
dnl     http://www.apache.org/licenses/LICENSE-2.0
dnl
dnl Unless required by applicable law or agreed to in writing, software
dnl distributed under the License is distributed on an "AS IS" BASIS,
dnl WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
dnl See the License for the specific language governing permissions and
dnl limitations under the License.

dnl Usage:
dnl AC_GLITE
dnl - GLITE_LOCATION
dnl - GLITE_CFLAGS
dnl - GLITE_LDFLAGS
dnl - DISTTAR

AC_DEFUN([AC_GLITE],
[
    AC_ARG_WITH(glite_location,
        [  --with-glite-location=PFX     prefix where GLITE is installed. (/opt/glite)],
        [],
        with_glite_location=${GLITE_LOCATION:-/opt/glite})

    AC_MSG_CHECKING([for gLite location])

    if test -n "with_glite_location" ; then
    	GLITE_LOCATION="$with_glite_location"
	GLITE_CFLAGS="-I$GLITE_LOCATION/include"
        if test "x$host_cpu" = "xx86_64"; then
            GLITE_LDFLAGS="-L$GLITE_LOCATION/lib64"
        else
            GLITE_LDFLAGS="-L$GLITE_LOCATION/lib"
        fi
        AC_MSG_RESULT([$with_glite_location])
    else
        AC_MSG_ERROR([$with_glite_location: no such directory])
    fi

    AC_SUBST(GLITE_LOCATION)
    AC_SUBST(GLITE_CFLAGS)
    AC_SUBST(GLITE_LDFLAGS)

])
