dnl Copyright (c) Istituto Nazionale di Fisica Nucleare (INFN). 2006-2010.
dnl
dnl Licensed under the Apache License, Version 2.0 (the "License");
dnl you may not use this file except in compliance with the License.
dnl You may obtain a copy of the License at
dnl
dnl     http://www.apache.org/licenses/LICENSE-2.0
dnl
dnl Unless required by applicable law or agreed to in writing, software
dnl distributed under the License is distributed on an "AS IS" BASIS,
dnl WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
dnl See the License for the specific language governing permissions and
dnl limitations under the License.

dnl Usage:
dnl AC_THREADPOOL
dnl - THREADPOOL_CFLAGS

AC_DEFUN([AC_THREADPOOL],
[

   AC_ARG_WITH(threadpool_include,
           [  --with-threadpool-include=PFX     prefix where THREADPOOL INCLUDE is installed. (/opt/boost/include)],
           [],
           with_threadpool_include=/opt/boost/include)

   AC_MSG_CHECKING([for THREADPOOL installation at ${with_threadpool_include}])

   if test -n "$with_threadpool_include" ; then
      THREADPOOL_CFLAGS="-I$with_threadpool_include"
   else
      THREADPOOL_CFLAGS=""
   fi

   AC_SUBST(THREADPOOL_CFLAGS)
])
